#include <amxmodx>

#define PLUGIN	"Map On Time"
#define AUTHOR	"BaHeK"
#define VERSION	"0.5"

#define PATH_CFG "mot.ini"
#define BLOCK_CFG "mot_block.ini"
#define HUD_TASK 1432

new Array:MapsTime

enum _:MapsTime_items
{
	map[32],
	starttime,
	stoptime
}

new mapname[32], tekmap = -1, gtime_string[3][32], g_pcvarEndround

public plugin_init()
{
	register_plugin(PLUGIN, VERSION, AUTHOR)
	MapsTime = ArrayCreate(MapsTime_items)
	get_mapname(mapname, charsmax(mapname))
	g_pcvarEndround = register_cvar("mot_endround", "0")
	read_cfg_and_calls()
	register_logevent("round_end", 2, "1=Round_End")
}

public round_end()
{
	if(get_pcvar_num(g_pcvarEndround))
		chek_and_show()
}

public block_cmds()
{
	if(tekmap != -1)
		return PLUGIN_HANDLED
	return PLUGIN_CONTINUE
}

public read_cfg_and_calls()
{
	new f_configsDir[64], f_configsFile[96]
	new f_textline[64]
	new temp[32], temp_pos, temp_line = 0, temp_mapdir[64], temp_item[MapsTime_items]
	
	get_localinfo("amxx_configsdir", f_configsDir, charsmax(f_configsDir))
	formatex(f_configsFile, charsmax(f_configsFile), "%s/%s", f_configsDir, PATH_CFG)
	
	if(!file_exists(f_configsFile))
	{
		log_amx("Файл ^"%s^" не найдет. Плагин остановлен.", f_configsFile) 
		pause("ad")
	}
	new File = fopen(f_configsFile, "r")
	while (!feof(File))
	{
		temp_line++
		fgets(File, f_textline, charsmax(f_textline))
		trim(f_textline)
		if (f_textline[0]==';' || !contain(f_textline, "//"))
			continue
		if(!strlen(f_textline))
			continue

		if(f_textline[2]==':')
		{
			if(f_textline[5] != ' ')
			{
				log_amx("Ошибка при парсинге строки: %d", temp_line)
				continue
			}
			formatex(temp, charsmax(temp), "%c%c", f_textline[0], f_textline[1])
			if(!is_str_num(temp))
			{
				log_amx("Ошибка при парсинге строки: %d", temp_line)
				continue
			}
			temp_item[starttime] = str_to_num(temp)*60
			formatex(temp, charsmax(temp), "%c%c", f_textline[3], f_textline[4])
			if(!is_str_num(temp))
			{
				log_amx("Ошибка при парсинге строки: %d", temp_line)
				continue
			}
			temp_item[starttime] += str_to_num(temp)
			temp_pos = 6
		}
		else
		{
			if(f_textline[2] != ' ')
			{
				log_amx("Ошибка при парсинге строки: %d", temp_line)
				continue
			}
			formatex(temp, charsmax(temp), "%c%c", f_textline[0], f_textline[1])
			if(!is_str_num(temp))
			{
				log_amx("Ошибка при парсинге строки: %d", temp_line)
				continue
			}
			temp_item[starttime] = str_to_num(temp)*60
			temp_pos = 3
		}
		if(f_textline[temp_pos+2]==':')
		{
			if(f_textline[temp_pos+5] != ' ')
			{
				log_amx("Ошибка при парсинге строки: %d", temp_line)
				continue
			}
			formatex(temp, charsmax(temp), "%c%c", f_textline[temp_pos], f_textline[temp_pos+1])
			if(!is_str_num(temp))
			{
				log_amx("Ошибка при парсинге строки: %d", temp_line)
				continue
			}
			temp_item[stoptime] = str_to_num(temp)*60
			formatex(temp, charsmax(temp), "%c%c", f_textline[temp_pos+3], f_textline[temp_pos+4])
			if(!is_str_num(temp))
			{
				log_amx("Ошибка при парсинге строки: %d", temp_line)
				continue
			}
			temp_item[stoptime] += str_to_num(temp)
			temp_pos += 6
		}
		else
		{			
			if(f_textline[temp_pos+2] != ' ')
			{
				log_amx("Ошибка при парсинге строки: %d", temp_line)
				continue
			}
			formatex(temp, charsmax(temp), "%c%c", f_textline[temp_pos], f_textline[temp_pos+1])
			if(!is_str_num(temp))
			{
				log_amx("Ошибка при парсинге строки: %d", temp_line)
				continue
			}
			temp_item[stoptime] = str_to_num(temp)*60
			temp_pos += 3
		}
		copy(temp, charsmax(temp), f_textline[temp_pos])
		format(temp_mapdir, charsmax(temp_mapdir), "maps/%s.bsp", temp)
		if(!file_exists(temp_mapdir))
		{
			log_amx("Карты %s нет на сервере", temp)
			continue
		}
		temp_item[map] = temp
		ArrayPushArray(MapsTime, temp_item)
	}
	fclose(File)
	pre_chek()
	formatex(f_configsFile, charsmax(f_configsFile), "%s/%s", f_configsDir, BLOCK_CFG)
	if(!file_exists(f_configsFile))
	{
		return
	}
	File = fopen(f_configsFile, "r")
	while (!feof(File))
	{
		fgets(File, f_textline, charsmax(f_textline))
		trim(f_textline)
		if (f_textline[0]==';' || !contain(f_textline, "//"))
			continue
		if(!strlen(f_textline))
			continue
		register_clcmd(f_textline, "block_cmds")
	}
	fclose(File)
}

public pre_chek()
{
	new count = ArraySize(MapsTime)
	if(!count)
	{
		log_amx("Нет загруженных карт. Плагин остановлен.") 
		pause("ad")
	}
	log_amx("Загружено расписаний: %d", count)
	chek_and_show()
}

public chek_and_show()
{
	new f_timeHours
	new f_timeMinutes
	new timenum
	new temp_item[MapsTime_items]
	new bool:endtime = false
	
	time(f_timeHours, f_timeMinutes)
	timenum = f_timeHours*60+f_timeMinutes
		
	for(new i = tekmap==-1 ? 0 : tekmap; i < ArraySize(MapsTime); i++)
	{
		ArrayGetArray(MapsTime, i, temp_item)
		if(temp_item[starttime] > temp_item[stoptime])
			temp_item[stoptime] += 1440
		
		if((timenum >= temp_item[starttime] && timenum < temp_item[stoptime]) || (timenum+1440 >= temp_item[starttime] && timenum+1440 < temp_item[stoptime]))
		{
			if(i != tekmap)
			{
				if(equali(mapname, temp_item[map]))
				{
					server_cmd("mp_timelimit 0")
					remove_task(HUD_TASK)
					temp_item[stoptime] = temp_item[stoptime]>1440 ? temp_item[stoptime]-1440 : temp_item[stoptime]
					new len
					len = formatex(gtime_string[0], charsmax(gtime_string[]), "%s%d:", temp_item[starttime]/60<10 ? "0" : "", temp_item[starttime]/60)
					len += formatex(gtime_string[0][len], charsmax(gtime_string[]) - len, "%s%d", temp_item[starttime]%60<10 ? "0" : "", temp_item[starttime]%60)
					len = formatex(gtime_string[1], charsmax(gtime_string[]), "%s%d:", temp_item[stoptime]/60<10 ? "0" : "", temp_item[stoptime]/60)
					len += formatex(gtime_string[1][len], charsmax(gtime_string[]) - len, "%s%d", temp_item[stoptime]%60<10 ? "0" : "", temp_item[stoptime]%60)
					set_task(1.0, "show_hud", HUD_TASK, _, _, "b")
					tekmap = i
				}
				else
					server_cmd("changelevel %s", temp_item[map])
			}
			endtime = true
			break
		}
	}
	if(!endtime && tekmap != -1)
	{
		server_cmd("exec server.cfg")
		tekmap = -1
		remove_task(HUD_TASK)
	}
	
	if(!get_pcvar_num(g_pcvarEndround))
		set_task(60.0, "chek_and_show")
}

public show_hud()
{
	set_hudmessage(255, 170, 0, 0.16, 0.0, 0, 0.0, 1.1)
	show_hudmessage (0, "На сервере включена карта %s с %s до %s", mapname, gtime_string[0], gtime_string[1])
}